SystemOrganization addCategory: #PO1!

Object subclass: #JuegoDeLucha
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PO1'!

!JuegoDeLucha methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:36'!
determinarGanadosEntreJugador: unJugador y: otroJugador
	| resultado turno mov1 mov2|
	
	turno := 0.
	[ turno < 10 ]
			whileTrue:
				[ mov1 := unJugador jugadaParaTurno: turno. 
				  mov2 := otroJugador jugadaParaTurno: turno.
				  mov1 afectarA: otroJugador reacciona: mov2.  
				  mov2 afectarA: unJugador reacciona: mov1.
				  (self perdioAlguno: unJugador y: otroJugador)
						ifTrue: [ turno := 10.]
						ifFalse: [turno := turno +1].			
				].
	Transcript show: (self resultado: unJugador y: otroJugador);cr.
	
		! !

!JuegoDeLucha methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:28'!
perdioAlguno: unJugador y: otroJugador
	^((unJugador energia <= 0) | (otroJugador energia <= 0 ) )
			
		! !

!JuegoDeLucha methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:30'!
resultado: unJugador y: otroJugador
	(unJugador energia == otroJugador energia)
		ifTrue: [ ^'Empate' ].
	(unJugador energia > otroJugador energia)
		ifTrue: [ ^'El primer Jugador Gana' ].
	(unJugador energia < otroJugador energia)
		ifTrue: [ ^'El segundo Jugador Gana' ].
		 	
		! !

Object subclass: #JugadorDeLucha
	instanceVariableNames: 'nombre energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PO1'!

!JugadorDeLucha class methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:34'!
newNombre: unNombre
	|jug|
	jug := super new.
	jug nombre: unNombre.
	 ^jug.! !

!JugadorDeLucha methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 16:46'!
energia
	^ energia! !

!JugadorDeLucha methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 16:46'!
energia: anObject
	energia := anObject! !

!JugadorDeLucha methodsFor: 'initialization' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:31'!
initialize 
	self energia: 100.! !

!JugadorDeLucha methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 16:51'!
jugadaParaTurno: unTurno
	|col|
	col := OrderedCollection new.
	col add: (Golpe new);
	     add: (Bloqueo new).
	^col atRandom.! !

!JugadorDeLucha methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 16:46'!
nombre
	^ nombre! !

!JugadorDeLucha methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 16:46'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Movimiento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PO1'!

Movimiento subclass: #Bloqueo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PO1'!

!Bloqueo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:24'!
afectarA: otroJugador reacciona: mov2  

	mov2 afectarAAnteBloqueoA: otroJugador.! !

!Bloqueo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:26'!
afectarAAnteBloqueoA: otroJugador.! !

!Bloqueo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:26'!
afectarAAnteGolpeA: otroJugador.! !

Movimiento subclass: #Golpe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PO1'!

!Golpe methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:24'!
afectarA: otroJugador reacciona: mov2  

	mov2 afectarAAnteGolpeA: otroJugador.! !

!Golpe methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:35'!
afectarAAnteBloqueoA: otroJugador.
	otroJugador energia: otroJugador energia - 10.! !

!Golpe methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:35'!
afectarAAnteGolpeA: otroJugador.
	otroJugador energia: otroJugador energia /100 * 80.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:49'!
afectarA: otroJugador reacciona: mov2  
	self subclassResponsibility.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:49'!
afectarAAnteBloqueoA: otroJugador.
	self subclassResponsibility.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 17:50'!
afectarAAnteGolpeA: otroJugador.
	self subclassResponsibility.! !
